%==========================================================================
%   TP Multivariable : simulation du mouvement en 2D
%   Auteurs:        DP, SR, YM
%   Modifications:  DP-20090929
%   Contact:        damien.perritaz@epfl.ch
%   Assistants:     DP, AB
%==========================================================================

function affichage(TSPAN,X_History,fig)

%parametre physique du systeme
parametresPhysiques;  

% Affichage
figure(fig)
hold on

%definition de l etat
state=X_History;
time=5*TSPAN; % facteur modifie la vitesse d'affichage

% Definition du Sol
xsol1 = -10;
xsol2 = 10;
ysol1 = 0;
ysol2 = 0;

% Definition de la Roue
cercle = [0:0.01:2*pi];
xcercle = R*cos(cercle);
ycercle = R*sin(cercle) + R;

%Horloge d affichage
tic
time_disp = 0;

while (time_disp < time(end))
    time_disp = toc;
    %state_disp = linint([time; state],time_disp);    %interpolation lineaire
    
    i=find(time-time_disp<0);
    state_disp=state(:,i(end));
    
    % Pendule
    x1 = state_disp(1);
    y1 = R;
    x2 = state_disp(1) + sin(state_disp(2))*2*d;
    y2 = R + cos(state_disp(2))*2*d;
    % Pendule initial
    x1_0 = state(1,1);
    y1_0 = R;
    x2_0 = state(1,1) + sin(state(2,1))*2*d;
    y2_0 = R + cos(state(2,1))*2*d;
    % Roue
    xcerclefinal =  xcercle + state_disp(1);
    % Rayon
    xrayon1 = state_disp(1) + [-R R].*cos(-state_disp(1)/R);
    yrayon1 = R + [-R R].*sin(-state_disp(1)/R);
    xrayon2 = state_disp(1) + [-R R].*cos(-state_disp(1)/R + pi/2);
    yrayon2 = R + [-R R].*sin(-state_disp(1)/R + pi/2);
    clf;
    % Sol
    plot([xsol1 xsol2],[ysol1 ysol2],'k');
    grid
    hold on;
    % Pendule
    plot([x1 x2],[y1 y2],'b');
    %Pendule initial
    plot([x1_0 x2_0],[y1_0 y2_0],'c');
    % Roue
    plot(xcerclefinal,ycercle,'r');
    % Rayon 
    plot(xrayon1,yrayon1,'r');
    plot(xrayon2,yrayon2,'r');
    axis equal
    axis([min(state(:,1))-cos(max(state(:,2)))*2*d max(state(:,1))+cos(min(state(:,2)))*2*d -0.2 1.4]);
    xlabel('deplacement horizontal en xi')
    drawnow;
end

return 